/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include <stdio.h>

typedef struct _Pool {
    int desc;
    void* ptr;
    struct _Pool* next;
} Pool;

static Pool* root = NULL;

void
purify_map_pool(int desc, void (*free_func)(void *))
{
    Pool* p;
    Pool* next;
    Pool** pp = &root;

    while (*pp != NULL) {
	p = *pp;
	next = p->next;
	if (p->desc == desc) {
	    *pp = next;
	    free_func(p->ptr);
	    free(p);
	}
	pp = &(next->next);
    }
}

void
purify_set_pool_id(void* ptr, int desc)
{
    Pool* p = (Pool *) malloc(sizeof(Pool));

    p->desc = desc;
    p->ptr = ptr;
    p->next = root;
    root = p;
    
}

void
purify_clear_pool_id(int desc, void* ptr)
{
    Pool** pp;
    Pool* p;

    pp = &root;
    while (*pp != NULL) {
	p = *pp;
	if (p->ptr == ptr && p->desc == desc) {
	    *pp = p->next;
	    free(p);
	    return;
	}
	pp = &(p->next);
    }
}

