/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "erl_interface.h"
#include "ei.h"
#include "putget.h"

/* the actual encoder */
extern int erl_encode_it(ETERM *ep, unsigned char **ext);
     
extern int ei_encode_term(char *buf, int *index, void *t)
{
  char *s = buf + *index;
  char *s0 = s;

  if (!buf) s += erl_term_len(t) -1; /* -1 for version */
  else {
    /* this encodes all but the version at the start */
    /* and it will move s forward the right number of bytes */
    if (erl_encode_it(t,(unsigned char **)&s)) return -1;
  }
  
  *index += s - s0;
  
  return 0;
}

