/* ``The contents of this file are subject to the Erlang Public License,
 * Version 1.0, (the "License"); you may not use this file except in
 * compliance with the License. You may obtain a copy of the License at
 * http://www.erlang.org/EPL1_0.txt
 * 
 * Software distributed under the License is distributed on an "AS IS"
 * basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See
 * the License for the specific language governing rights and limitations
 * under the License.
 * 
 * The Original Code is Erlang-4.7.3, December, 1998.
 * 
 * The Initial Developer of the Original Code is Ericsson Telecom
 * AB. Portions created by Ericsson are Copyright (C), 1998, Ericsson
 * Telecom AB. All Rights Reserved.
 * 
 * Contributor(s): ______________________________________.''
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif
#include "eihash.h"

/* this is a general prime factoring function 
 * we get one prime factor each time we call it 
 * we only use it here to determine if n is prime, 
 * by checking if factor(n) == n .
 */
static int factor(int n)
{
  static int a[] = { 0, 4, 1, 2, 0, 2 };
  static int m = 0;
  static int d = 0;

  if (n) {
    m = n;
    d = 2;
  }

  while ((d*d) <= m) {
    if (!(m%d)) {
      m /= d;
      return d;
    }
    d += a[d%6];
  }
  n = m; 
  m = 0;

  return n;
}

/* true if n prime */
extern int ei_isprime(int n)
{
  return (n == factor(n));
}
