%% Copyright (C) 1992, 1996, Ericsson Telecom, Sweden
%% Author: Carl Wilhelm Welin 08/7273557

%% This is the syntax (metagrammar) of grammar definitions of the yecc
%% parser generator.

Nonterminals
grammar declaration rule head symbol symbols attached_code
token tokens.

Terminals
atom float integer reserved_symbol string var '->' ':' 'dot'.

Rootsymbol grammar.

grammar -> declaration : '$1'.
grammar -> rule : '$1'.
declaration -> symbol symbols 'dot': {'$1', '$2'}.
rule -> head '->' symbols attached_code 'dot': {rule, ['$1' | '$3'], '$4'}.
head -> symbol : '$1'.
symbols -> symbol : ['$1'].
symbols -> symbol symbols : ['$1' | '$2'].
attached_code -> ':' tokens : {erlang_code, '$2'}.
attached_code -> '$empty' : {erlang_code, [{atom, 0, '$undefined'}]}.
tokens -> token : ['$1'].
tokens -> token tokens : ['$1' | '$2'].
symbol -> var : value_of('$1').
symbol -> atom : value_of('$1').
symbol -> integer : value_of('$1').
token -> var : '$1'.
token -> atom : '$1'.
token -> float : '$1'.
token -> integer : '$1'.
token -> string : '$1'.
token -> reserved_symbol : {value_of('$1'), line_of('$1')}.
token -> '->' : {'->', line_of('$1')}. % Have to be treated in this
token -> ':' : {':', line_of('$1')}.   % manner, because they are also
				       % special symbols of the metagrammar

Erlang code.

value_of(Token) ->
    element(3, Token).

line_of(Token) ->
    element(2, Token).
